#property copyright "PipDefender - by Lorenzo Borrelli - 2011"
#property link "ellebimail@gmail.com"
  
#import "pipdlib.dll"
   double OrderPipProfit( double p1[], double p2[] );   
   double OrderPrice( double p1[] );
   string OrderPriceName( double p1[] );
   string OrderTypeToString( double p1[] );
   int IsSafe ( int p1[], double p2[] );
   void StealthMode( int p1[], double p2[], double p3[], int& p4[], double& p5[], double& p6[] );
   int SafeMode( int p1[], double p2[], double p3[], int p4 );
   void ManageProfit( int p1[], double p2[], double p3[], int& p4[], double& p5[], double& p6[], double& p7[] );
   int Ignore( int p1[], int p2[], int p3[], int p4, int p5, int p6, int p7, int p8 );
   void KamikazeProtect( int p1[], double p2[], double p3[], int& p4[], double& p5[], double& p6[] );
   void Breakeven( int p1[], double p2[], double p3[], int& p4[], double& p5[], double& p6[] );
   int KamikazeClose ( double p1[] );
   string CheckParams( int p1[], double p2[] );
   int SetEnvironment( int p1, double p2, double p3, double& p4[], double& p5[], int& p6[] );
#import "pipdlib.ex4"

#define _VERSION_NUMBER "1.333"
#define _VERSION_INFO "v1.333 by Lorenzo Borrelli - 2011"

// PIPDEFENDER CONST
#define PIPD_FALSE 0                   // "boolean" value for FALSE returned from dll functions
#define PIPD_TRUE 1                    // "boolean" value for TRUE returned from dll functions
#define PIPD_MODIFY -1                 // command action: "modify order" (sl & tp are passed separately)
#define PIPD_CLOSE -2                  // command action: "close order"
#define PIPD_ABORT  -3                 // ABORT command sent from the dll
#define PIPD_NOTHING -19740204         // command action: "no action"
#define PIPD_D_NOTHING -1974.0204      // double "null" value

// Other constants
#define _INDENT  "\n          "
#define _INDENT2 "       "
#define _PROMPT "==>       "
#define _PARTIAL_CLOSE_HEADER "FROM #"
#define _PARTIAL_CLOSE_HEADER_LENGTH 6
#define _SEPARATOR ""
#define _SEPARATOR2 ""
#define MIN_FONT_SIZE 8
#define BASE_FONT_SIZE 11
#define MAX_FONT_SIZE 20
#define _ALL_OK 0                       // no exceptions, the EA continue to work normally
#define _ALERT -1                       // An "Alert" box will be shown, the EA suspend every other activity
#define _ABORT -2                       // An "Alert" box will be shown, the EA abort and will be removed from its chart
#define _SUSPEND -3                     // Special value used to avoid multiple Alert boxes
#define _PAUSE -4                       // Pause mode
#define _CONTEXT_MAXTRY 5               // maximum number of consecutive retry for a context check
#define _CLOSE_MAXTRY 3                 // maximum number of consecutive retry for a CloseOrder function
#define _MODIFY_MAXTRY 3                // maximum number of consecutive retry for the ModifyOrder function
#define _BUSY_SLEEPTIME 150             // default sleeptime when the trade context is busy or the OrderSend fails
#define _ZERO 0.00000000                // zero

// INDEXES NAMES atart with the _ character
// FLAGS array indexes
#define _KAMIKAZE_MODE 0
#define _GREEDY_MODE 1
#define _STEALTH_MODE 2
#define _SAFE_MODE 3
#define _BREAKEVEN_MODE 4
// PARAMS array indexes
#define _TRAILING_START 0
#define _TRAILING_STOP 1
#define _TRAILING_STEP 2
#define _GREEDY_SECS 3
#define _GREEDY_DECAY 4
#define _BREAKEVEN_AFTER 5
#define _BREAKEVEN_CLOSE_PERCENT 6
#define _TRUE_SL 7
#define _FAKE_SL 8
#define _MAX_HOURS_WARNING 9
#define _MAX_HOURS_ALARM 10
#define _SAFE_LOSS 11
#define _CLOSE_SLIPPAGE 12
#define _POINT_VALUE 13
#define _X_STOPLEVEL 14
// ORDER array indexes
#define _O_TICKET 0	// int
#define _O_TYPE 1	// int
#define _M_BID 2
#define _M_ASK 3
#define _O_OPENPRICE 4
#define _O_OPENTIME 5	// int
#define _O_TAKEPROFIT 6
#define _O_STOPLOSS 7
#define _O_PIPPROFIT 8
#define _O_KSTOPLOSS 9
#define _O_CURR_TRAILING_STOP 10
#define _O_PREV_TIME 11
#define _O_PREV_PRICE 12
#define _O_CURR_TIME 13

// -------------------------------------------------------------------------------------------------------------------------------
// EXTERNAL PARAMETERS
// -------------------------------------------------------------------------------------------------------------------------------
// --- Standard mode parameters
extern string _____PIPDEFENDER_VERSION = _VERSION_INFO;
extern bool PAUSE = true;                    // when false PIPD go in pause mode
extern string _____PROFIT_MODE_PARAMETERS = _SEPARATOR;
extern double TRAILING_START = 4.0;          // PIP
extern double TRAILING_STOP = 3.0;           // PIP
extern double TRAILING_STEP = 1.0;           // PIP
extern bool GREEDY_MODE = false;             // Enable or disable the greedy mode
extern int GREEDY_SECS = 0;                  // seconds
extern int GREEDY_DECAY = 20;                // percentage
extern bool KAMIKAZE_MODE = false;
extern bool KAMIKAZE_PROTECTION = false;     
extern bool BREAKEVEN_MODE = false;          // overriding every other strategy PD will try to set a BE point when (and if) possible
extern double BREAKEVEN_AFTER = 0;           // PIP
extern int BREAKEVEN_CLOSE_PERCENT = 0;      // partial close percentage 0-100 
// --- Stealth mode parameters
extern string _____STALTH_MODE_PARAMETERS = _SEPARATOR;
extern bool STEALTH_MODE = false;      // Enable or disable the internal SL management
extern double TRUE_SL = 40.0;          // PIP
extern double FAKE_SL = 150.0;         // PIP
// --- Safe mode parameters string
extern string _____SAFE_MODE_PARAMETERS = _SEPARATOR;
extern bool SAFE_MODE = false;         // Enable or disable the safe mode
extern double MAX_HOURS_WARNING = 8.0;
extern double MAX_HOURS_ALARM = 16.0;
extern double SAFE_LOSS = 4.0;         // Max "safe" PIP loss after MAX_HOURS
extern string _____OTHER_PARAMETERS = _SEPARATOR;
extern double CLOSE_SLIPPAGE = 0.5;    // PIP
extern string EXCLUDE_MAGIC = "";      // comma separated list of magic numbers or ""
extern string INCLUDE_MAGIC = "";      // comma separated list of magic numbers or ""
extern string EXCLUDE_TICKET = "";     // comma separated list of ticket numbers or ""
// --- Additional stuff
extern string _____ADDITIONAL_STUFF = _SEPARATOR;
extern string NOTE = "Active till 2011-06-30";
extern bool SHOW_PANEL = true;         // Enable or disable the info panel
extern bool COMPACT_INFO = false;      // compact the info panel
extern bool EXTRA_LUCK = false;        // enable or disable a bit of extra luck for your trades
//extern int LANGUAGE = 826;        // ENG or ITA
extern bool PRINT_LOG = true;          // Enable or disable log messages 
extern color PANEL_COLOR = Gold;
extern int FONT_SIZE = 11;             // GUI font size
 
int FLAGS[5];
double PARAMS[15];

// NUMERIC
double NormalizeDigits( double value );
string DoubleDigitsToString( double value );
string DoubleOneDigitToString( double price );

// UTILITY
//string Lng( int n, int lngcode );
int WriteAtLine( int line, color textColor, int fontSize, string text );
void AddLine( color textColor, int fontSize, string text );
void ClearLinesFrom( int startLine );
void Tokenize(int& output[], string input, string token);
void Die();
string StringToUpperCase( string sText );
string StringToLowerCase( string sText );